#version 330
#extension GL_ARB_separate_shader_objects : enable
precision highp float;
precision highp sampler2D;
precision highp sampler2DMS;
precision highp samplerCube;

layout(location = 0) in vec3 _vin_Position;
layout(location = 1) in vec4 _vin_Color;

struct SVertexInput
{
	vec3 Position;
	vec4 Color;
	int VertexIndex;
	uint InstanceId;
};

layout(location = 0) smooth out vec4 _vout_fragColor;

struct SVertexOutput
{
	vec4 fragColor;
	vec4 VertexPosition;
};

layout( std140) uniform USceneInfo
{
	mat4 ViewProj;
	mat4 View;
	mat4 Proj;
	mat4 InvView;
	mat4 InvViewProj;
	mat4 InvView_FrameRhYUp;
	mat4 LHZToUser;
	vec4 ViewPosition;
	vec4 ViewDirection;
	vec4 DirLightPosition;
	vec4 DirLightColor;
	vec4 AmbientLightColor;
	vec4 SideVector;
	vec4 DepthVector;
	vec2 ZBufferLimits;
	float Handedness;
} SceneInfo;



void VertexMain(in SVertexInput vInput, out SVertexOutput vOutput)
{




	vOutput.VertexPosition =  (( SceneInfo.ViewProj ) * (vec4(vInput.Position, 1.0))) ;



	vOutput.fragColor = vInput.Color;
}


void main()
{
	SVertexInput vInput;
	SVertexOutput vOutput;

	vInput.Position = _vin_Position;
	vInput.Color = _vin_Color;
	vInput.VertexIndex = gl_VertexID;
	vInput.InstanceId = uint(gl_InstanceID);
	vOutput.fragColor = vec4(0, 0, 0, 0);
	VertexMain(vInput, vOutput);
	_vout_fragColor = vOutput.fragColor;
	gl_Position = vOutput.VertexPosition;
}
