
#define	VULKAN_API

#define	GLUE(_a, _b)						_a ## _b

#define	VEC4_ZERO							vec4(0,0,0,0)
#define	VEC4_ONE							vec4(1,1,1,1)
#define	VEC3_ZERO							vec3(0,0,0)
#define	VEC3_ONE							vec3(1,1,1)
#define	VEC2_ZERO							vec2(0,0)
#define	VEC2_ONE							vec2(1,1)

#define	ANY_BOOL(_bvec)						any(_bvec)

#define	BUILD_MAT2(_axisX, _axisY)						mat2(_axisX, _axisY)
#define	BUILD_MAT3(_axisX, _axisY, _axisZ)				mat3(_axisX, _axisY, _axisZ)
#define	BUILD_MAT4(_axisX, _axisY, _axisZ, _axisW)		mat4(_axisX, _axisY, _axisZ, _axisW)

#define	GET_CONSTANT(_constant, _var)					_constant._var
#define	GET_RAW_BUFFER(_buffer)						_buffer._buffer

#define	TEXTURE_DIMENSIONS(_sampler, _lod, _dimensions)		_dimensions = textureSize(_sampler, _lod);
#define	SAMPLE(_sampler, _uv)								texture(_sampler, _uv)
#define	SAMPLE_CUBE(_sampler, _uv)							SAMPLE(_sampler, _uv)
# define	FETCH(_sampler, _uv)								texelFetch(_sampler, _uv.xy, _uv.z)
# define	SAMPLEMS(_sampler, _uv, _sampleID)					texelFetch(_sampler, _uv, _sampleID)
#define	SAMPLELOD(_sampler, _uv, _lod)						textureLod(_sampler, _uv, _lod)
#define	SAMPLELOD_CUBE(_sampler, _uv, _lod)					SAMPLELOD(_sampler, _uv, _lod)

#define	RAW_BUFFER_INDEX(_index)					_index

#define	LOADU(_name, _index)						_name[_index]
#define	LOADU2(_name, _index)						ivec2(_name[_index], _name[(_index) + 1])
#define	LOADU3(_name, _index)						ivec3(_name[_index], _name[(_index) + 1], _name[(_index) + 2])
#define	LOADU4(_name, _index)						ivec4(_name[_index], _name[(_index) + 1], _name[(_index) + 2], _name[(_index) + 3])

#define	LOADF(_name, _index)						asfloat(_name[_index])
#define	LOADF2(_name, _index)						vec2(asfloat(_name[_index]), asfloat(_name[(_index) + 1]))
#define	LOADF3(_name, _index)						vec3(asfloat(_name[_index]), asfloat(_name[(_index) + 1]), asfloat(_name[(_index) + 2]))
#define	LOADF4(_name, _index)						vec4(asfloat(_name[_index]), asfloat(_name[(_index) + 1]), asfloat(_name[(_index) + 2]), asfloat(_name[(_index) + 3]))

#define	asuint(x)									floatBitsToUint(x)
#define	asfloat(x)									uintBitsToFloat(x)

#define	mul(_a,_b)									((_a) * (_b))

#define	ARRAY_BEGIN(_type)							_type[] (
#define	ARRAY_END()									)

#define	SAMPLER2D_DCL_ARG(_sampler)					sampler2D _sampler
#define	SAMPLER2DMS_DCL_ARG(_sampler)				sampler2DMS _sampler

#define	SAMPLER_ARG(_sampler)						_sampler
#define	SAMPLERMS_ARG(_sampler)						_sampler

#define	SATURATE(_value)							clamp(_value, 0.0, 1.0)
#define	CAST(_type, _value)							_type(_value)

#define	CROSS(_a, _b)								cross(_a, _b)

#define	IN(_type)									in _type
#define	OUT(_type)									out _type
#define	INOUT(_type)								inout _type

#define	GS_PARAMS
#define	GS_ARGS
#define	VS_PARAMS
#define	VS_ARGS
#define	FS_PARAMS
#define	FS_ARGS

#define	VERSION								#version 450
#define	EXTENSION							#extension GL_ARB_separate_shader_objects : enable
#define	rsqrt(x)							(1.0 / sqrt(x))
#define	GET_MATRIX_X_AXIS(_mat)				_mat[0]
#define	GET_MATRIX_Y_AXIS(_mat)				_mat[1]
#define	GET_MATRIX_Z_AXIS(_mat)				_mat[2]
#define	GET_MATRIX_W_AXIS(_mat)				_mat[3]
VERSION
EXTENSION

bool any(bool r) { return r; }
bool all(bool r) { return r; }

layout(location = 0) in vec2 _vin_TexCoords;

struct	SVertexInput
{
	vec2 TexCoords;
	int VertexIndex;
	uint InstanceId;
};

layout(location = 0) smooth out vec4 _vtof_fragColor;

struct	SVertexOutput
{
	vec4 fragColor;
	vec4 VertexPosition;
};

layout(set = 0, binding = 0) uniform USceneInfo
{
	mat4 ViewProj;
	mat4 View;
	mat4 Proj;
	mat4 InvView;
	mat4 InvViewProj;
	mat4 InvView_FrameRhYUp;
	mat4 LHZToUser;
	vec4 DirLightPosition;
	vec4 DirLightColor;
	vec4 AmbientLightColor;
	vec4 SideVector;
	vec4 DepthVector;
	vec2 ZBufferLimits;
	float Handedness;
}		SceneInfo;
layout(set = 1, binding = 0) readonly buffer BEnabledsOffsets
{
	uint EnabledsOffsets[];
} EnabledsOffsets;
layout(set = 1, binding = 1) readonly buffer BPositionsOffsets
{
	uint PositionsOffsets[];
} PositionsOffsets;
layout(set = 1, binding = 2) readonly buffer BSizesOffsets
{
	uint SizesOffsets[];
} SizesOffsets;
layout(set = 1, binding = 3) readonly buffer BAxis0sOffsets
{
	uint Axis0sOffsets[];
} Axis0sOffsets;
layout(set = 2, binding = 0) readonly buffer BGPUSimData
{
	uint GPUSimData[];
} GPUSimData;

layout(push_constant) uniform UStagePushConstant
{
	layout(offset = 0) vec4 DrawRequest[1];
	layout(offset = 16) uint IndicesOffset;
}		StagePushConstant;
#define BillboardInfo StagePushConstant
#define GPUBillboardPushConstants StagePushConstant

vec2 get_radius(uint particleID VS_ARGS)
{




	float _radius = LOADF(GET_RAW_BUFFER(GPUSimData), LOADU(GET_RAW_BUFFER(SizesOffsets), RAW_BUFFER_INDEX(GET_CONSTANT(GPUBillboardPushConstants, StreamOffsetsIndex))) + RAW_BUFFER_INDEX(particleID));
	return vec2(_radius, _radius);
}


void RotateTangents(uint particleID, INOUT(vec3) tangent0, INOUT(vec3) tangent1 VS_ARGS)
{
}


vec4 proj_position(IN(vec3) position VS_ARGS)
{

	return mul(GET_CONSTANT(SceneInfo, ViewProj), vec4(position, 1.0f));
}


vec3 ComputeTangent1(IN(vec3) nrm, IN(vec3) tangent0 VS_ARGS)
{
	vec3 side = GET_CONSTANT(SceneInfo, SideVector).xyz;
	vec3 depth = GET_CONSTANT(SceneInfo, DepthVector).xyz;

	vec3 tangent1 =  cross(nrm, tangent0) * GET_CONSTANT(SceneInfo, Handedness) ;
	if (dot(tangent1, tangent1) >  1.0e-8f )
		tangent1 = normalize(tangent1);
	else
	{
		const vec3 v = -side * dot(nrm, depth) + depth * (dot(nrm, side) + 0.01f);
		tangent1 = normalize( cross(nrm, v) * GET_CONSTANT(SceneInfo, Handedness) );
	}
	return tangent1;
}


void VertexBillboard(IN(SVertexInput) vInput, INOUT(SVertexOutput) vOutput, uint particleID VS_ARGS)
{

	const uint storageId = GET_CONSTANT(GPUBillboardPushConstants, StreamOffsetsIndex);
	const vec3 worldPos = LOADF3(GET_RAW_BUFFER(GPUSimData), LOADU(GET_RAW_BUFFER(PositionsOffsets), RAW_BUFFER_INDEX(storageId)) + RAW_BUFFER_INDEX(particleID * 3));
	const uint drId = 0;
	const vec4 currentDr = GET_CONSTANT(BillboardInfo, DrawRequest)[drId];
	const uint flags = asuint(currentDr.x);
	const uint billboarderType = flags &  7U ;

	const vec2 radius = get_radius(particleID VS_PARAMS);
	vec3 tangent0 = vec3(0, 0, 0);
	vec3 tangent1 = vec3(0, 0, 0);
	vec2 texCoords = vInput.TexCoords;
	switch (billboarderType)
	{

	case  1U :
	{
		tangent0 = GET_MATRIX_X_AXIS(GET_CONSTANT(SceneInfo, InvView_FrameRhYUp)).xyz * radius.x;
		tangent1 = GET_MATRIX_Y_AXIS(GET_CONSTANT(SceneInfo, InvView_FrameRhYUp)).xyz * radius.y;
		RotateTangents(particleID, tangent0, tangent1 VS_PARAMS);
		break;
	}


	case  2U :
	{
		const vec3 viewPos = GET_MATRIX_W_AXIS(GET_CONSTANT(SceneInfo, InvView_FrameRhYUp)).xyz;
		const vec3 camToParticle = normalize(worldPos - viewPos);
		const vec3 upVector =  cross(GET_CONSTANT(SceneInfo, DepthVector).xyz, GET_CONSTANT(SceneInfo, SideVector).xyz) * GET_CONSTANT(SceneInfo, Handedness) ;
		const vec3 upAxis = upVector + 0.01f * dot(upVector, camToParticle) * GET_CONSTANT(SceneInfo, DepthVector).xyz;

		tangent0 = normalize( cross(camToParticle, upAxis) * GET_CONSTANT(SceneInfo, Handedness) );
		tangent1 =  cross(tangent0, camToParticle) * GET_CONSTANT(SceneInfo, Handedness)  * radius.y;
		tangent0 *= radius.x;
		RotateTangents(particleID, tangent0, tangent1 VS_PARAMS);
		break;
	}


	case  3U :
	{
		const vec3 viewPos = GET_MATRIX_W_AXIS(GET_CONSTANT(SceneInfo, InvView_FrameRhYUp)).xyz;
		const vec3 camToParticle = normalize(worldPos - viewPos);


		const vec3 axis_fwd = LOADF3(GET_RAW_BUFFER(GPUSimData), LOADU(GET_RAW_BUFFER(Axis0sOffsets), RAW_BUFFER_INDEX(storageId)) + RAW_BUFFER_INDEX(particleID * 3));
		tangent0 = ComputeTangent1(camToParticle, axis_fwd VS_PARAMS) * radius.x;
		tangent1 = axis_fwd * 0.5f;
		break;
	}


	case  4U :
	{
		const vec3 viewPos = GET_MATRIX_W_AXIS(GET_CONSTANT(SceneInfo, InvView_FrameRhYUp)).xyz;
		const vec3 camToParticle = normalize(worldPos - viewPos);


		const vec3 axis_fwd = LOADF3(GET_RAW_BUFFER(GPUSimData), LOADU(GET_RAW_BUFFER(Axis0sOffsets), RAW_BUFFER_INDEX(storageId)) + RAW_BUFFER_INDEX(particleID * 3));
		tangent0 = ComputeTangent1(camToParticle, axis_fwd VS_PARAMS) * radius.x;
		tangent1 = axis_fwd * 0.5f +  cross(tangent0, camToParticle) * GET_CONSTANT(SceneInfo, Handedness) ;
		break;
	}


	case  5U :
	{
		const vec3 viewPos = GET_MATRIX_W_AXIS(GET_CONSTANT(SceneInfo, InvView_FrameRhYUp)).xyz;
		const vec3 camToParticle = normalize(worldPos - viewPos);


		const vec3 axis_fwd = LOADF3(GET_RAW_BUFFER(GPUSimData), LOADU(GET_RAW_BUFFER(Axis0sOffsets), RAW_BUFFER_INDEX(storageId)) + RAW_BUFFER_INDEX(particleID * 3));
		tangent0 = ComputeTangent1(camToParticle, axis_fwd VS_PARAMS) * radius.x;
		tangent1 = axis_fwd * 0.5f;


		tangent0 *= -1.0f;


		const float upAxisStretch = abs(texCoords.y) - 1.0f;
		tangent1 -=  cross(tangent0, camToParticle) * GET_CONSTANT(SceneInfo, Handedness)  * upAxisStretch;
		texCoords.y = clamp(texCoords.y, -1.0f, 1.0f);
		break;
	}
	default:
		break;
	}


	tangent1 *= -1.0f;


	const vec3 bbCorner = tangent0 * texCoords.x + tangent1 * texCoords.y;
	const vec3 vertexWorldPosition = worldPos + bbCorner;

	vOutput.VertexPosition = proj_position(vertexWorldPosition VS_PARAMS);
}

void VertexMain(IN(SVertexInput) vInput, OUT(SVertexOutput) vOutput VS_ARGS)
{
	const uint indicesOffset = GET_CONSTANT(GPUBillboardPushConstants, IndicesOffset);

		const uint storageId = GET_CONSTANT(GPUBillboardPushConstants, StreamOffsetsIndex);
		const uint particleID = vInput.InstanceId;
	float degenerate = 1.0f;





	vOutput.fragColor = vec4(1.0, 1.0, 1.0, 1.0);
	VertexBillboard(vInput, vOutput, particleID VS_PARAMS);

	vOutput.VertexPosition *= degenerate;
}


void	main()
{
	SVertexInput	vInput;
	SVertexOutput	vOutput;

	vInput.TexCoords = _vin_TexCoords;
	vInput.VertexIndex = gl_VertexIndex;
	vInput.InstanceId = uint(gl_InstanceIndex);

	VertexMain(vInput, vOutput);
	_vtof_fragColor = vOutput.fragColor;
	gl_Position = vOutput.VertexPosition;
}

